-- Specjalizazcja dla Bizon Z020
-- 03.10.2019
-- Rockstar94


Z020Cutter = {};

function Z020Cutter.prerequisitesPresent(specializations)
    return	true
end

function Z020Cutter.registerFunctions(vehicleType)
	SpecializationUtil.registerFunction(vehicleType, "playerTriggerCheck", Z020Cutter.playerTriggerCheck)
	SpecializationUtil.registerFunction(vehicleType, "actionEventTextUpdate", Z020Cutter.actionEventTextUpdate)
end

function Z020Cutter.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onRegisterActionEvents", Z020Cutter)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", Z020Cutter);
	SpecializationUtil.registerEventListener(vehicleType, "onDelete", Z020Cutter);
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", Z020Cutter);
end

function Z020Cutter:onRegisterActionEvents(isActiveForInput, isActiveForInputIgnoreSelection)
	if self.spec_cover.actionEvents[InputAction.TOGGLE_COVER] ~= nil then
		self:removeActionEvent(self.spec_cover.actionEvents, InputAction.TOGGLE_COVER);
	end
	if self.spec_cylindered.actionEvents[InputAction.ROTATE_OBJECT_LEFT_RIGHT] ~= nil then
		self:removeActionEvent(self.spec_cylindered.actionEvents, InputAction.ROTATE_OBJECT_LEFT_RIGHT);
	end
end;

function Z020Cutter:onLoad(savegame)
	self.playerTrigger = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.cover.playerTrigger#node"));
	addTrigger(self.playerTrigger, "playerTriggerCheck", self); 
	self.playerInTrigger = false;
	self.actionEvents = {};
end

function Z020Cutter:onDelete()
	removeTrigger(self.playerTrigger)
end

function Z020Cutter:onUpdate(dt)
	if self.playerInTrigger then
		if self.configurations["cover"] == 2 then
			self:actionEventTextUpdate()
			g_inputBinding:setActionEventActive(self.actionEventMouseId, self.spec_cover.state == #self.spec_cover.covers and self:getIsTurnedOn() == false)
		else	
			g_inputBinding:setActionEventActive(self.actionEventMouseId, self:getIsTurnedOn() == false)
		end
		if self:getIsTurnedOn() == true then
			g_currentMission:addExtraPrintText(g_i18n:getText("info_z020_turnOffVehicleToChangeReelPosition"));
		end
	end
    if self.isClient then
		if not self:getRootVehicle():getIsActive() then
			self:raiseActive()
		end
	end
end

function Z020Cutter:playerTriggerCheck(triggerId, otherId, onEnter, onLeave, onStay)
    if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		if self.configurations["cover"] == 2 then
			_, self.actionEventId = self:addActionEvent(self.actionEvents, InputAction.TOGGLE_COVER, self, Cover.actionEventToggleCover, false, true, false, true, nil);
			self:actionEventTextUpdate()
		end;
		_, self.actionEventMouseId = self:addActionEvent(self.actionEvents, InputAction.Z020_REEL_LEFT_RIGHT, self, Z020Cutter.reelLeftRightMove, false, false, true, true, nil, self.spec_cylindered.movingTools[2].axisActionIcon);
		self.playerInTrigger = true;	
    elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		if self.configurations["cover"] == 2 then
			self:removeActionEvent(self.actionEvents, InputAction.TOGGLE_COVER);
		end
		self:removeActionEvent(self.actionEvents, InputAction.Z020_REEL_LEFT_RIGHT);
		self.playerInTrigger = false;
    end;
end;

function Z020Cutter:actionEventTextUpdate()
	if self.spec_cover.state == #self.spec_cover.covers then
		g_inputBinding:setActionEventText(self.actionEventId, g_i18n:getText("action_closeCover"))
	elseif self.spec_cover.state == 0 then
		g_inputBinding:setActionEventText(self.actionEventId, g_i18n:getText("action_openCover"))
	end;
end

function Z020Cutter.reelLeftRightMove(self, actionName, inputValue, callbackState, isAnalog, isMouse)
	self.spec_cylindered.movingTools[2].move = inputValue
end